import java.util.Vector;

public class FaceWE {
 

  private ArestaWE aresta;
  
/**
 * Construtor.
 */
  public FaceWE(){
    aresta = new ArestaWE();
  }
  /**
   * Construtor
   * @param a Aresta associada a essa face.
   */
  public FaceWE(ArestaWE a){
    this.aresta = a;
    
  }
  
  /**
   * Seta uma aresta dessa face.
   */
  public void setAresta(ArestaWE a){
    this.aresta = a;
    
    //if(a.fccw==null)
    //    a.fccw=this;
    //else{ 
    //if(a.fcw==null)
    //a.fcw=this;
    //else{
    //System.out.println("FaceWE::FaceWE(ArestaWE) Aresta inserida ja possui duas faces ");
    //System.exit(1);
    //}
    //}
 
 }
  
  /**
   * Devolve a aresta dessa face.
   * Devolve null caso essa face ainda no tenha sido associada a nenhuma aresta.
   */
  public ArestaWE getAresta(){
    return this.aresta;
  }
  
  
  public Vector getArestasLivres(){
    Vector vet = new Vector();
    
    //System.out.println(" $$$ Entrou em getArestasLivres() $$$");

    if(aresta==null){
      //System.out.println("$$$ FaceWE::getArestasLivres A aresta dessa face eh null");
      System.exit(1);
    }
    if(aresta.fccw == null || aresta.fcw==null)
      vet.addElement(aresta);

    //Descobrimos se essa face eh fccw ou fcw no nossa Aresta
    if(aresta.fccw != null && this.equals(aresta.fccw))
    {

      if(aresta.nccw.fccw==null || aresta.nccw.fcw==null){
	vet.addElement(aresta.nccw);
      }
      if(aresta.pccw.fccw==null || aresta.pccw.fcw==null){
	vet.addElement(aresta.pccw);
      }
    }else
      if( aresta.fcw != null && this.equals(aresta.fcw))
      {
	if(aresta.ncw==null){
	  //System.out.println("FaceWE::getArestasLivres()  Erro: aresta.ncw eh nulo!!");
	  //System.exit(1);
	}
	if(aresta.pcw==null){
	  //System.out.println("FaceWE::getArestasLivres()  Erro: aresta.pcw eh nulo!!");
	  //System.exit(1);
	}
	if(aresta.nccw==null){
	  //System.out.println("FaceWE::getArestasLivres()  Erro: aresta.nccw eh nulo!!");
	  //System.exit(1);
	}
	if(aresta.pccw==null){
	  //System.out.println("FaceWE::getArestasLivres()  Erro: aresta.pccw eh nulo!!");
	  //System.exit(1);
	}
	
	if(aresta.ncw.fccw==null || aresta.ncw.fcw==null){
	  vet.addElement(aresta.ncw);
	}
	if(aresta.pcw.fccw==null || aresta.pcw.fcw==null){
	  vet.addElement(aresta.pcw);
	}
      }else{
	//System.out.println("FaceWE::getArestasLivres() Aresta apontada por esta face ainda nao foi atualizada pra apontar pra essa face");
	System.exit(1);
      }
    
    //System.out.println("$$$ Imprimindo lista de arestas livres!! $$$");
    for(int j=0; j< vet.size(); j++){
      ArestaWE edge = (ArestaWE) vet.elementAt(j);
      //System.out.println("$$$ Aresta livre "+j+" "+edge.print());
    }
    
    return vet;
  }

  public VerticeWE getOutroVertice(){
    return null;
  }
 


}//end of class Face.

